#---
# Excerpted from "The ThoughtWorks Anthology 2",
# published by The Pragmatic Bookshelf.
# Copyrights apply to this code. It may not be used to create training material, 
# courses, books, articles, and the like. Contact us if you are in doubt.
# We make no guarantees that this code is fit for any purpose. 
# Visit http://www.pragmaticprogrammer.com/titles/twa2 for more book information.
#---
class Greeter
  def hi
    'hi'
  end
end

['hello', 'goodbye'].each do |greeting|
  Greeter.class_eval <<-MULTILINE_STRING
    def #{greeting}(name)
      "#{greeting} \#{name}!"
    end
  MULTILINE_STRING
end
greeter = Greeter.new
puts greeter.hello('Aman') #=> hello Aman!
puts greeter.goodbye('King') #=> goodbye King!
